Subject: bug#10376: [Bug 908354] Re: tail -0f /var/log/kern.log never prints anything (livecd cow overlayfs)

From: Jim Meyering <[email-masked]>
Date: Tue, 27 Dec 2011 10:48:10 +0100

[ following up to this report,
  http://bugs.launchpad.net/+source/coreutils/+bug/908354
  ]

Tuomas Heino wrote:
> ubuntu@ubuntu:~$ stat -f --format %t:%T /var/log
> 1021994:tmpfs

Thanks.

Unlike most file system types, overlayFS appears to have no magic number.
Now we're seeing how using files on such a file system can cause trouble.
I see no direct way to distinguish this file (for which inotify does not
work) from any other on a tmpfs file system, for which inotify works
just fine.

Ugly work-around: tail -f could try using both inotify and polling,
and, eventually, if polling spots a change for which there was no
inotify event, it would give up on using inotify for that file.
As soon as tail sees an inotify event for a file, however, it could
not stop polling: for most remote FS types, inotify works with changes
generated locally, but not with those generated remotely.  So polling
can still be useful when using inotify.

We'll see...